unit Unit1;

interface

uses
  System.ComponentModel,
  Borland.Vcl.Windows,
  Borland.Vcl.Messages,
  Borland.Vcl.SysUtils,
  Borland.Vcl.Variants,
  Borland.Vcl.Classes,
  Borland.Vcl.Graphics,
  Borland.Vcl.Controls,
  Borland.Vcl.Forms,
  Borland.Vcl.Dialogs,
  Borland.Vcl.StdCtrls,
  Borland.Vcl.Db,
  KA.Ado.Utils;

type
  TForm1 = class(TForm)
    KAAdoUtils1: TKAAdoUtils;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    procedure Button8Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.nfm}
//******************************************************* Create Access Database
procedure TForm1.Button1Click(Sender: TObject);
begin
  KAAdoUtils1.Database := Edit1.Text;
  KAAdoUtils1.Action   := dbCreateDatabase;
  KAAdoUtils1.Activate := True;
  ShowMessage('Database "'+Edit1.Text+'" created!');
end;

//******************************************* Compact and Repair Access Database
procedure TForm1.Button2Click(Sender: TObject);
begin
  KAAdoUtils1.Database := Edit1.Text;
  KAAdoUtils1.Action   := dbCompactDatabase;
  KAAdoUtils1.Activate := True;
  ShowMessage('Database "'+Edit1.Text+'" compacted!');
end;

//************************************************* Create Table in the Database
procedure TForm1.Button3Click(Sender: TObject);
Var
  NewField : TFieldItem;
begin
  Try
    KAAdoUtils1.Database   := Edit1.Text;
    KAAdoUtils1.Connected  := True;
    KAAdoUtils1.Action     := dbCreateTable;
    KAAdoUtils1.TableName  := Edit2.Text;
    KAAdoUtils1.Fields.Clear;

    NewField                  := KAAdoUtils1.Fields.AddField;
    NewField.FieldName        := 'ID';
    NewField.FieldType        := ftAutoInc;
    NewField.RandomIncrement  := True;
    NewField.FieldSize        := 0;

    NewField                  := KAAdoUtils1.Fields.AddField;
    NewField.FieldName        := 'GUID';
    NewField.FieldType        := ftGUID;
    NewField.AutoInc          := True;

    KAAdoUtils1.Activate      := True;
    ShowMessage('Table "'+Edit2.Text+'" created!');
  Finally
    KAAdoUtils1.Connected  := False;
  End;
end;

//************************************************ Create New Field in the Table
procedure TForm1.Button4Click(Sender: TObject);
Var
  NewField : TFieldItem;
begin
  Try
    KAAdoUtils1.Database     := Edit1.Text;
    KAAdoUtils1.Connected    := True;
    KAAdoUtils1.Action       := dbCreateFields;
    KAAdoUtils1.TableName    := Edit2.Text;
    KAAdoUtils1.Fields.Clear;
    NewField                 := KAAdoUtils1.Fields.AddField;
    NewField.FieldName       := Edit3.Text;
    NewField.FieldType       := ftString;
    NewField.FieldSize       := 100;
    NewField.CompressUnicode := True;
    NewField.AllowNulls      := False;
    NewField.AllowZeroLength := False;
    NewField.DefaultValue    := 'Text';
    KAAdoUtils1.Activate     := True;
    ShowMessage('Field "'+Edit3.Text+'" created!');
  Finally
    KAAdoUtils1.Connected  := False;
  End;
end;
//************************************************ Create New Index in the Table
procedure TForm1.Button5Click(Sender: TObject);
Var
  NewField : TIndexFieldItem;
begin
  Try
    KAAdoUtils1.Database             := Edit1.Text;
    KAAdoUtils1.Connected            := True;
    KAAdoUtils1.Action               := dbCreateIndex;
    KAAdoUtils1.TableName            := Edit2.Text;
    //******************************* Create PrimaryKey index (just for example)
    KAAdoUtils1.IndexName            := 'PrimaryKey';
    KAAdoUtils1.IndexProp_Members.Clear;
    NewField                         := KAAdoUtils1.IndexProp_Members.AddField;
    NewField.FieldName               := 'ID';
    NewField.SortOrder               := Ascending;
    KAAdoUtils1.IndexProp_PrimaryKey := True;
    KAAdoUtils1.IndexProp_Unique     := True;
    KAAdoUtils1.IndexProp_Nulls      := Allow;
    KAAdoUtils1.Activate             := True;
    //******************************* Create normal index
    KAAdoUtils1.IndexProp_Members.Clear;
    KAAdoUtils1.IndexName            := Edit4.Text;
    NewField                         := KAAdoUtils1.IndexProp_Members.AddField;
    NewField.FieldName               := 'ID';
    NewField                         := KAAdoUtils1.IndexProp_Members.AddField;
    NewField.FieldName               := Edit3.Text;
    NewField.SortOrder               := Descending;
    KAAdoUtils1.IndexProp_PrimaryKey := False;
    KAAdoUtils1.IndexProp_Unique     := True;
    KAAdoUtils1.IndexProp_Nulls      := Ignore;
    KAAdoUtils1.Activate             := True;
    ShowMessage('Index "'+Edit4.Text+'" created!');
  Finally
    KAAdoUtils1.Connected  := False;
  End;

end;

//***************************************************************** Delete Index
procedure TForm1.Button6Click(Sender: TObject);
Begin
  Try
    KAAdoUtils1.Database             := Edit1.Text;
    KAAdoUtils1.Connected            := True;
    KAAdoUtils1.Action               := dbDeleteIndex;
    KAAdoUtils1.TableName            := Edit2.Text;
    //******************************* Delete PrimaryKey index
    KAAdoUtils1.IndexName            := 'PrimaryKey';
    KAAdoUtils1.Activate             := True;
    //******************************* Delete normal index
    KAAdoUtils1.IndexName            := Edit4.Text;
    KAAdoUtils1.Activate             := True;
    ShowMessage('Index "'+Edit4.Text+'" deleted!');
  Finally
    KAAdoUtils1.Connected  := False;
  End;
end;

//***************************************************************** Delete Field
procedure TForm1.Button7Click(Sender: TObject);
begin
  Try
    KAAdoUtils1.Database             := Edit1.Text;
    KAAdoUtils1.Connected            := True;
    KAAdoUtils1.Action               := dbDeleteField;
    KAAdoUtils1.TableName            := Edit2.Text;
    KAAdoUtils1.FieldName            := Edit3.Text;
    KAAdoUtils1.Activate             := True;
    ShowMessage('Field "'+Edit3.Text+'" deleted!');
  Finally
    KAAdoUtils1.Connected  := False;
  End;
end;

//***************************************************************** Delete Table
procedure TForm1.Button8Click(Sender: TObject);
begin
begin
  Try
    KAAdoUtils1.Database             := Edit1.Text;
    KAAdoUtils1.Connected            := True;
    KAAdoUtils1.Action               := dbDeleteTable;
    KAAdoUtils1.TableName            := Edit2.Text;
    KAAdoUtils1.Activate             := True;
    ShowMessage('Table "'+Edit2.Text+'" deleted!');
  Finally
    KAAdoUtils1.Connected  := False;
  End;
end;

end;

end.
